Index: /pjproject/trunk/pjmedia/build/pjmedia_videodev.vcproj
===================================================================
--- /pjproject/trunk/pjmedia/build/pjmedia_videodev.vcproj	(revision 4536)
+++ /pjproject/trunk/pjmedia/build/pjmedia_videodev.vcproj	(revision 4537)
@@ -18,4 +18,7 @@
 		/>
 		<Platform
+			Name="x64"
+		/>
+		<Platform
 			Name="Windows Mobile 6 Standard SDK (ARMV4I)"
 		/>
@@ -226,4 +229,64 @@
 		</Configuration>
 		<Configuration
+			Name="Debug|x64"
+			ConfigurationType="4"
+			InheritedPropertySheets="..\..\build\vs\pjproject-vs8-debug-static-defaults.vsprops;..\..\build\vs\pjproject-vs8-win64-common-defaults.vsprops"
+			UseOfMFC="0"
+			ATLMinimizesCRunTimeLibraryUsage="false"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+				TargetEnvironment="3"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="../include,../../pjlib/include,../../pjlib-util/include,../../pjnath/include,../../third_party/portaudio/include,../../third_party/speex/include,../../third_party/build/srtp,../../third_party/srtp/crypto/include,../../third_party/srtp/include,../..,../../third_party/BaseClasses"
+				PreprocessorDefinitions="_LIB;"
+				PrecompiledHeaderFile=""
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="..\lib\pjmedia-videodev-$(TargetCPU)-$(PlatformName)-vc$(VSVer)-$(ConfigurationName).lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+		<Configuration
 			Name="Release|Win32"
 			ConfigurationType="4"
@@ -418,4 +481,63 @@
 		</Configuration>
 		<Configuration
+			Name="Release|x64"
+			ConfigurationType="4"
+			InheritedPropertySheets="..\..\build\vs\pjproject-vs8-release-dynamic-defaults.vsprops;..\..\build\vs\pjproject-vs8-win64-release-defaults.vsprops"
+			UseOfMFC="0"
+			ATLMinimizesCRunTimeLibraryUsage="false"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+				TargetEnvironment="3"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="../include,../../pjlib/include,../../pjlib-util/include,../../pjnath/include,../../third_party/portaudio/include,../../third_party/speex/include,../../third_party/build/srtp,../../third_party/srtp/crypto/include,../../third_party/srtp/include,../..,../../third_party/BaseClasses"
+				PreprocessorDefinitions="_LIB;"
+				PrecompiledHeaderFile=""
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="..\lib\pjmedia-videodev-$(TargetCPU)-$(PlatformName)-vc$(VSVer)-$(ConfigurationName).lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+		<Configuration
 			Name="Debug-Static|Win32"
 			ConfigurationType="4"
@@ -610,4 +732,64 @@
 		</Configuration>
 		<Configuration
+			Name="Debug-Static|x64"
+			ConfigurationType="4"
+			InheritedPropertySheets="..\..\build\vs\pjproject-vs8-debug-static-defaults.vsprops;..\..\build\vs\pjproject-vs8-win64-common-defaults.vsprops"
+			UseOfMFC="0"
+			ATLMinimizesCRunTimeLibraryUsage="false"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+				TargetEnvironment="3"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="../include,../../pjlib/include,../../pjlib-util/include,../../pjnath/include,../../third_party/portaudio/include,../../third_party/speex/include,../../third_party/build/srtp,../../third_party/srtp/crypto/include,../../third_party/srtp/include,../..,../../third_party/BaseClasses"
+				PreprocessorDefinitions="_LIB;"
+				PrecompiledHeaderFile=""
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="..\lib\pjmedia-videodev-$(TargetCPU)-$(PlatformName)-vc$(VSVer)-$(ConfigurationName).lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+		<Configuration
 			Name="Release-Dynamic|Win32"
 			ConfigurationType="4"
@@ -802,4 +984,63 @@
 		</Configuration>
 		<Configuration
+			Name="Release-Dynamic|x64"
+			ConfigurationType="4"
+			InheritedPropertySheets="..\..\build\vs\pjproject-vs8-release-dynamic-defaults.vsprops;..\..\build\vs\pjproject-vs8-win64-release-defaults.vsprops"
+			UseOfMFC="0"
+			ATLMinimizesCRunTimeLibraryUsage="false"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+				TargetEnvironment="3"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="../include,../../pjlib/include,../../pjlib-util/include,../../pjnath/include,../../third_party/portaudio/include,../../third_party/speex/include,../../third_party/build/srtp,../../third_party/srtp/crypto/include,../../third_party/srtp/include,../..,../../third_party/BaseClasses"
+				PreprocessorDefinitions="_LIB;"
+				PrecompiledHeaderFile=""
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="..\lib\pjmedia-videodev-$(TargetCPU)-$(PlatformName)-vc$(VSVer)-$(ConfigurationName).lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+		<Configuration
 			Name="Debug-Dynamic|Win32"
 			ConfigurationType="4"
@@ -994,4 +1235,64 @@
 		</Configuration>
 		<Configuration
+			Name="Debug-Dynamic|x64"
+			ConfigurationType="4"
+			InheritedPropertySheets="..\..\build\vs\pjproject-vs8-debug-dynamic-defaults.vsprops;..\..\build\vs\pjproject-vs8-win64-common-defaults.vsprops"
+			UseOfMFC="0"
+			ATLMinimizesCRunTimeLibraryUsage="false"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+				TargetEnvironment="3"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="../include,../../pjlib/include,../../pjlib-util/include,../../pjnath/include,../../third_party/portaudio/include,../../third_party/speex/include,../../third_party/build/srtp,../../third_party/srtp/crypto/include,../../third_party/srtp/include,../..,../../third_party/BaseClasses"
+				PreprocessorDefinitions="_LIB;"
+				PrecompiledHeaderFile=""
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="..\lib\pjmedia-videodev-$(TargetCPU)-$(PlatformName)-vc$(VSVer)-$(ConfigurationName).lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+		<Configuration
 			Name="Release-Static|Win32"
 			ConfigurationType="4"
@@ -1183,4 +1484,63 @@
 			/>
 			<DebuggerTool
+			/>
+		</Configuration>
+		<Configuration
+			Name="Release-Static|x64"
+			ConfigurationType="4"
+			InheritedPropertySheets="..\..\build\vs\pjproject-vs8-release-static-defaults.vsprops;..\..\build\vs\pjproject-vs8-win64-release-defaults.vsprops"
+			UseOfMFC="0"
+			ATLMinimizesCRunTimeLibraryUsage="false"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+				TargetEnvironment="3"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="../include,../../pjlib/include,../../pjlib-util/include,../../pjnath/include,../../third_party/portaudio/include,../../third_party/speex/include,../../third_party/build/srtp,../../third_party/srtp/crypto/include,../../third_party/srtp/include,../..,../../third_party/BaseClasses"
+				PreprocessorDefinitions="_LIB;"
+				PrecompiledHeaderFile=""
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="..\lib\pjmedia-videodev-$(TargetCPU)-$(PlatformName)-vc$(VSVer)-$(ConfigurationName).lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
 			/>
 		</Configuration>
Index: /pjproject/trunk/pjmedia/include/pjmedia-audiodev/config.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia-audiodev/config.h	(revision 4536)
+++ /pjproject/trunk/pjmedia/include/pjmedia-audiodev/config.h	(revision 4537)
@@ -51,4 +51,5 @@
 #ifndef PJMEDIA_AUDIO_DEV_HAS_PORTAUDIO
 #   if (defined(PJ_WIN32) && PJ_WIN32!=0) || \
+       (defined(PJ_WIN64) && PJ_WIN64!=0) || \
        (defined(PJ_SYMBIAN) && PJ_SYMBIAN!=0)
 #	define PJMEDIA_AUDIO_DEV_HAS_PORTAUDIO	0
Index: /pjproject/trunk/pjmedia/include/pjmedia/circbuf.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/circbuf.h	(revision 4536)
+++ /pjproject/trunk/pjmedia/include/pjmedia/circbuf.h	(revision 4537)
@@ -217,5 +217,6 @@
     *reg1_len = circbuf->len;
     if (*reg1 + *reg1_len > circbuf->buf + circbuf->capacity) {
-	*reg1_len = circbuf->buf + circbuf->capacity - circbuf->start;
+	*reg1_len = (unsigned)(circbuf->buf + circbuf->capacity - 
+			       circbuf->start);
 	*reg2 = circbuf->buf;
 	*reg2_len = circbuf->len - *reg1_len;
@@ -253,7 +254,7 @@
     *reg1_len = circbuf->capacity - circbuf->len;
     if (*reg1 + *reg1_len > circbuf->buf + circbuf->capacity) {
-	*reg1_len = circbuf->buf + circbuf->capacity - *reg1;
+	*reg1_len = (unsigned)(circbuf->buf + circbuf->capacity - *reg1);
 	*reg2 = circbuf->buf;
-	*reg2_len = circbuf->start - circbuf->buf;
+	*reg2_len = (unsigned)(circbuf->start - circbuf->buf);
     } else {
 	*reg2 = NULL;
Index: /pjproject/trunk/pjmedia/include/pjmedia/frame.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/frame.h	(revision 4536)
+++ /pjproject/trunk/pjmedia/include/pjmedia/frame.h	(revision 4537)
@@ -232,5 +232,5 @@
     pjmedia_frame_ext_subframe *sf;
     pj_uint8_t *move_src;
-    unsigned move_len;
+    pj_size_t move_len;
 
     if (frm->subframe_cnt <= n) {
@@ -242,6 +242,6 @@
     move_src = (pj_uint8_t*)pjmedia_frame_ext_get_subframe(frm, n);
     sf = pjmedia_frame_ext_get_subframe(frm, frm->subframe_cnt-1);
-    move_len = (pj_uint8_t*)sf - move_src + sizeof(sf->bitlen) +
-	       ((sf->bitlen+7) >> 3);
+    move_len = ((pj_uint8_t*)sf - move_src + sizeof(sf->bitlen) +
+	       ((sf->bitlen+7) >> 3));
     pj_memmove((pj_uint8_t*)frm+sizeof(pjmedia_frame_ext),
 	       move_src, move_len);
Index: /pjproject/trunk/pjmedia/src/pjmedia-audiodev/errno.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-audiodev/errno.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-audiodev/errno.c	(revision 4537)
@@ -140,5 +140,5 @@
 	}
 #else
-	mr = (*waveGetErrText)(native_err, buf, bufsize);
+	mr = (*waveGetErrText)(native_err, buf, (UINT)bufsize);
 #endif
 
Index: /pjproject/trunk/pjmedia/src/pjmedia-audiodev/wmme_dev.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-audiodev/wmme_dev.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-audiodev/wmme_dev.c	(revision 4537)
@@ -743,5 +743,5 @@
     mr = waveOutOpen(&wmme_strm->hWave.Out, 
 		     wf->dev_info[prm->play_id].deviceId,
-		     &wfx, (DWORD)wmme_strm->hEvent, 0, flag);
+		     &wfx, (DWORD)(pj_ssize_t)wmme_strm->hEvent, 0, flag);
     if (mr != MMSYSERR_NOERROR) {
 	return PJMEDIA_AUDIODEV_ERRNO_FROM_WMME_OUT(mr);
@@ -834,5 +834,5 @@
     mr = waveInOpen(&wmme_strm->hWave.In, 
 		    wf->dev_info[prm->rec_id].deviceId, 
-		    &wfx, (DWORD)wmme_strm->hEvent, 0, flag);
+		    &wfx, (DWORD)(pj_ssize_t)wmme_strm->hEvent, 0, flag);
     if (mr != MMSYSERR_NOERROR) {
 	return PJMEDIA_AUDIODEV_ERRNO_FROM_WMME_IN(mr);
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/ffmpeg_vid_codecs.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/ffmpeg_vid_codecs.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/ffmpeg_vid_codecs.c	(revision 4537)
@@ -455,5 +455,5 @@
 	 */
 	if (data->fmtp.sprop_param_sets_len) {
-	    ctx->extradata_size = data->fmtp.sprop_param_sets_len;
+	    ctx->extradata_size = (int)data->fmtp.sprop_param_sets_len;
 	    ctx->extradata = data->fmtp.sprop_param_sets;
 	}
@@ -1289,8 +1289,8 @@
     ff->whole = (ff->param.packing == PJMEDIA_VID_PACKING_WHOLE);
     if (!ff->whole) {
-	ff->enc_buf_size = ff->enc_vafp.framebytes;
+	ff->enc_buf_size = (unsigned)ff->enc_vafp.framebytes;
 	ff->enc_buf = pj_pool_alloc(ff->pool, ff->enc_buf_size);
 
-	ff->dec_buf_size = ff->dec_vafp.framebytes;
+	ff->dec_buf_size = (unsigned)ff->dec_vafp.framebytes;
 	ff->dec_buf = pj_pool_alloc(ff->pool, ff->dec_buf_size);
     }
@@ -1421,5 +1421,5 @@
     PJ_ALIGN_DATA(pj_uint32_t i[4], 16);
 
-    if ((long)i & 0xF) {
+    if ((long)(pj_ssize_t)i & 0xF) {
 	PJ_LOG(2,(THIS_FILE, "Stack alignment fails"));
     }
@@ -1503,5 +1503,6 @@
 	whole_frm.size = ff->enc_buf_size;
 	status = ffmpeg_codec_encode_whole(codec, opt, input,
-	                                   whole_frm.size, &whole_frm);
+	                                   (unsigned)whole_frm.size, 
+					   &whole_frm);
 	if (status != PJ_SUCCESS)
 	    return status;
@@ -1619,5 +1620,5 @@
 		       (unsigned)ff->dec_buf_size,
 		       (unsigned)ff->dec_vafp.framebytes));
-	    ff->dec_buf_size = ff->dec_vafp.framebytes;
+	    ff->dec_buf_size = (unsigned)ff->dec_vafp.framebytes;
 	    ff->dec_buf = pj_pool_alloc(ff->pool, ff->dec_buf_size);
 	}
@@ -1682,5 +1683,5 @@
     av_init_packet(&avpacket);
     avpacket.data = (pj_uint8_t*)input->buf;
-    avpacket.size = input->size;
+    avpacket.size = (int)input->size;
 
     /* ffmpeg warns:
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/gsm.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/gsm.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/gsm.c	(revision 4537)
@@ -531,5 +531,5 @@
     struct gsm_data *gsm_data = (struct gsm_data*) codec->codec_data;
     pj_int16_t *pcm_in;
-    unsigned in_size;
+    pj_size_t in_size;
 
     pj_assert(gsm_data && input && output);
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/h263_packetizer.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/h263_packetizer.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/h263_packetizer.c	(revision 4537)
@@ -156,5 +156,5 @@
     *payload = p;
     *payload_len = end-p;
-    *pos = end - bits;
+    *pos = (unsigned)(end - bits);
 
     return PJ_SUCCESS;
@@ -274,5 +274,5 @@
     /* Write two zero octets when payload flagged with sync point */
     if (P) {
-	pktz->unpack_last_sync_pos = q - bits;
+	pktz->unpack_last_sync_pos = (unsigned)(q - bits);
         *q++ = 0;
         *q++ = 0;
@@ -284,5 +284,5 @@
 
     /* Update the bitstream writing offset */
-    *pos = q - bits;
+    *pos = (unsigned)(q - bits);
 
     pktz->unpack_prev_lost = PJ_FALSE;
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/h264_packetizer.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/h264_packetizer.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/h264_packetizer.c	(revision 4537)
@@ -215,5 +215,5 @@
 	else
 	    *payload_len = nal_end - nal_start + HEADER_SIZE_FU_A;
-	*pos = *payload + *payload_len - buf;
+	*pos = (unsigned)(*payload + *payload_len - buf);
 
 #if DBG_PACKETIZE
@@ -243,5 +243,5 @@
 	nal[0] = nal_start;
 	nal_size[0] = nal_end - nal_start;
-	total_size = nal_size[0] + HEADER_SIZE_STAP_A;
+	total_size = (int)nal_size[0] + HEADER_SIZE_STAP_A;
 	NRI = (*nal_octet & 0x60) >> 5;
 
@@ -267,5 +267,5 @@
 
 	    /* Update total payload size (2 octet NAL size + NAL) */
-	    total_size += (2 + nal_size[nal_cnt]);
+	    total_size += (2 + (int)nal_size[nal_cnt]);
 	    if (total_size <= pktz->cfg.mtu) {
 		pj_uint8_t tmp_nri;
@@ -307,5 +307,5 @@
 	    pj_assert(*payload >= buf+*pos);
 	    *payload_len = p - *payload;
-	    *pos = nal[nal_cnt-1] + nal_size[nal_cnt-1] - buf;
+	    *pos = (unsigned)(nal[nal_cnt-1] + nal_size[nal_cnt-1] - buf);
 
 #if DBG_PACKETIZE
@@ -322,5 +322,5 @@
     *payload = nal_start;
     *payload_len = nal_end - nal_start;
-    *pos = nal_end - buf;
+    *pos = (unsigned)(nal_end - buf);
 
 #if DBG_PACKETIZE
@@ -400,5 +400,5 @@
 
 	/* Update the bitstream writing offset */
-	*bits_pos = p - bits;
+	*bits_pos = (unsigned)(p - bits);
 	pktz->unpack_last_sync_pos = *bits_pos;
 
@@ -451,5 +451,5 @@
 
 	    /* Update the bitstream writing offset */
-	    *bits_pos = p - bits;
+	    *bits_pos = (unsigned)(p - bits);
 	    pktz->unpack_last_sync_pos = *bits_pos;
 	}
@@ -510,5 +510,5 @@
 
 	/* Update the bitstream writing offset */
-	*bits_pos = p - bits;
+	*bits_pos = (unsigned)(p - bits);
 	if (E) {
 	    /* Update the sync pos only if the end bit flag is set */
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/ilbc.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/ilbc.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/ilbc.c	(revision 4537)
@@ -669,5 +669,5 @@
     struct ilbc_codec *ilbc_codec = (struct ilbc_codec*)codec;
     pj_int16_t *pcm_in;
-    unsigned nsamples;
+    pj_size_t nsamples;
 #if defined(PJMEDIA_ILBC_CODEC_USE_COREAUDIO)&& PJMEDIA_ILBC_CODEC_USE_COREAUDIO
     UInt32 npackets;
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/speex_codec.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/speex_codec.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/speex_codec.c	(revision 4537)
@@ -841,5 +841,5 @@
 
     /* Copy the data into the speex bit-stream */
-    speex_bits_read_from(&spx->dec_bits, (char*)pkt, pkt_size);
+    speex_bits_read_from(&spx->dec_bits, (char*)pkt, (int)pkt_size);
 
     while (speex_get_next_frame(&spx->dec_bits) == 0 && 
@@ -878,5 +878,5 @@
     int tx = 0;
     spx_int16_t *pcm_in = (spx_int16_t*)input->buf;
-    unsigned nsamples;
+    pj_size_t nsamples;
 
     spx = (struct spx_private*) codec->codec_data;
@@ -953,5 +953,5 @@
 
     /* Copy the data into the bit-stream struct */
-    speex_bits_read_from(&spx->dec_bits, (char*)input->buf, input->size);
+    speex_bits_read_from(&spx->dec_bits, (char*)input->buf, (int)input->size);
     
     /* Set Speex dec_bits pointer to the start bit of the frame */
Index: /pjproject/trunk/pjmedia/src/pjmedia-videodev/avi_dev.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-videodev/avi_dev.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-videodev/avi_dev.c	(revision 4537)
@@ -629,5 +629,5 @@
 
         return pjmedia_vid_codec_decode(stream->adi->codec, 1, &enc_frame,
-                                        frame->size, frame);
+                                        (unsigned)frame->size, frame);
     } else {
         return pjmedia_port_get_frame(stream->adi->vid, frame);
Index: /pjproject/trunk/pjmedia/src/pjmedia-videodev/dshow_dev.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-videodev/dshow_dev.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-videodev/dshow_dev.c	(revision 4537)
@@ -634,5 +634,5 @@
 
     hr = SourceFilter_Deliver(stream->dgraph.csource_filter,
-                              frame->buf, frame->size);
+                              frame->buf, (long)frame->size);
     if (FAILED(hr))
         return hr;
Index: /pjproject/trunk/pjmedia/src/pjmedia-videodev/ffmpeg_dev.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-videodev/ffmpeg_dev.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia-videodev/ffmpeg_dev.c	(revision 4537)
@@ -279,5 +279,6 @@
             info->host_api = p;
 
-#if defined(PJ_WIN32) && PJ_WIN32!=0
+#if (defined(PJ_WIN32) && PJ_WIN32!=0) || \
+    (defined(PJ_WIN64) && PJ_WIN64!=0)
             info->def_devname = "0";
 #elif defined(PJ_LINUX) && PJ_LINUX!=0
Index: /pjproject/trunk/pjmedia/src/pjmedia/avi_player.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/avi_player.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/avi_player.c	(revision 4537)
@@ -159,5 +159,5 @@
 			   8000, 1, 16, 80);
 
-    port->fd = (pj_oshandle_t)-1;
+    port->fd = (pj_oshandle_t)(pj_ssize_t)-1;
     port->base.get_frame = &avi_get_frame;
     port->base.on_destroy = &avi_on_destroy;
@@ -786,5 +786,5 @@
     pj_assert(this_port->info.signature == SIGNATURE);
 
-    if (fport->fd != (pj_oshandle_t) -1)
+    if (fport->fd != (pj_oshandle_t) (pj_ssize_t)-1)
         pj_file_close(fport->fd);
     return PJ_SUCCESS;
Index: /pjproject/trunk/pjmedia/src/pjmedia/conference.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/conference.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/conference.c	(revision 4537)
@@ -710,5 +710,5 @@
 						const pj_str_t *name)
 {
-    unsigned len;
+    pj_size_t len;
 
     /* Sanity check. */
@@ -1525,6 +1525,6 @@
 	} else {
 
-	    pjmedia_copy_samples(frame, cport->rx_buf, count);
-	    cport->rx_buf_count -= count;
+	    pjmedia_copy_samples(frame, cport->rx_buf, (unsigned)count);
+	    cport->rx_buf_count -= (unsigned)count;
 	    if (cport->rx_buf_count) {
 		pjmedia_move_samples(cport->rx_buf, cport->rx_buf+count,
Index: /pjproject/trunk/pjmedia/src/pjmedia/endpoint.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 4537)
@@ -497,5 +497,5 @@
 
 	    for (i = 0; i < dec_fmtp->cnt; ++i) {
-		unsigned test_len = 2;
+		pj_size_t test_len = 2;
 
 		/* Check if buf still available */
@@ -683,5 +683,5 @@
 
 	    for (j = 0; j < dec_fmtp->cnt; ++j) {
-		unsigned test_len = 2;
+		pj_size_t test_len = 2;
 
 		/* Check if buf still available */
Index: /pjproject/trunk/pjmedia/src/pjmedia/ffmpeg_util.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/ffmpeg_util.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/ffmpeg_util.c	(revision 4537)
@@ -104,5 +104,5 @@
     enum { LOG_LEVEL = 5 };
     char buf[100];
-    int bufsize = sizeof(buf), len;
+    pj_size_t bufsize = sizeof(buf), len;
     pj_str_t fmt_st;
 
Index: /pjproject/trunk/pjmedia/src/pjmedia/format.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/format.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/format.c	(revision 4537)
@@ -141,5 +141,5 @@
 	    vfi->apply_fmt(vfi, &vafp);
 
-	    bps = vafp.framebytes * fps_num * (pj_size_t)8 / fps_denum;
+	    bps = (pj_uint32_t)vafp.framebytes * fps_num * (pj_size_t)8 / fps_denum;
 	    fmt->det.vid.avg_bps = fmt->det.vid.max_bps = bps;
         }
@@ -173,5 +173,5 @@
     /* Packed formats only use 1 plane */
     aparam->planes[0] = aparam->buffer;
-    aparam->strides[0] = stride;
+    aparam->strides[0] = (int)stride;
     aparam->plane_bytes[0] = aparam->framebytes;
 
Index: /pjproject/trunk/pjmedia/src/pjmedia/g711.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 4537)
@@ -524,5 +524,5 @@
 	pj_uint8_t *dst = (pj_uint8_t*) output->buf;
 
-	n = (input->size >> 1);
+	n = ((unsigned)input->size >> 1);
 	for (i=0; i!=n; ++i, ++dst) {
 	    *dst = pjmedia_linear2alaw(samples[i]);
@@ -532,5 +532,5 @@
 	pj_uint8_t *dst = (pj_uint8_t*) output->buf;
 
-	n = (input->size >> 1);
+	n = ((unsigned)input->size >> 1);
 	for (i=0; i!=n; ++i, ++dst) {
 	    *dst = pjmedia_linear2ulaw(samples[i]);
Index: /pjproject/trunk/pjmedia/src/pjmedia/jbuf.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/jbuf.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/jbuf.c	(revision 4537)
@@ -976,5 +976,5 @@
     min_frame_size = PJ_MIN(frame_size, jb->jb_frame_size);
     status = jb_framelist_put_at(&jb->jb_framelist, frame_seq, frame,
-				 min_frame_size, bit_info, ts,
+				 (unsigned)min_frame_size, bit_info, ts,
 				 PJMEDIA_JB_NORMAL_FRAME);
     
@@ -990,10 +990,10 @@
 	 */
 	distance = (frame_seq - jb_framelist_origin(&jb->jb_framelist)) -
-		   jb->jb_max_count + 1;
+		   (int)jb->jb_max_count + 1;
 	pj_assert(distance > 0);
 
 	removed = jb_framelist_remove_head(&jb->jb_framelist, distance);
 	status = jb_framelist_put_at(&jb->jb_framelist, frame_seq, frame,
-				     min_frame_size, bit_info, ts,
+				     (unsigned)min_frame_size, bit_info, ts,
 				     PJMEDIA_JB_NORMAL_FRAME);
 
@@ -1126,5 +1126,5 @@
     PJ_ASSERT_RETURN(jb && state, PJ_EINVAL);
 
-    state->frame_size = jb->jb_frame_size;
+    state->frame_size = (unsigned)jb->jb_frame_size;
     state->min_prefetch = jb->jb_min_prefetch;
     state->max_prefetch = jb->jb_max_prefetch;
Index: /pjproject/trunk/pjmedia/src/pjmedia/resample_port.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/resample_port.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/resample_port.c	(revision 4537)
@@ -193,5 +193,5 @@
 	    pjmedia_copy_samples((pj_int16_t*)frame->buf, 
 				 (const pj_int16_t*)tmp_frame.buf, 
-				 frame->size >> 1);
+				 (unsigned)frame->size >> 1);
 	}
 	return PJ_SUCCESS;
Index: /pjproject/trunk/pjmedia/src/pjmedia/rtcp.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/rtcp.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/rtcp.c	(revision 4537)
@@ -85,4 +85,5 @@
 
 #if (defined(PJ_WIN32) && PJ_WIN32!=0) || \
+    (defined(PJ_WIN64) && PJ_WIN64!=0) || \
     (defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0)
 
@@ -964,5 +965,5 @@
     pjmedia_rtcp_common *hdr;
     pj_uint8_t *p;
-    unsigned len;
+    pj_size_t len;
 
     PJ_ASSERT_RETURN(session && buf && length && sdes, PJ_EINVAL);
@@ -1037,5 +1038,5 @@
     pjmedia_rtcp_common *hdr;
     pj_uint8_t *p;
-    unsigned len;
+    pj_size_t len;
 
     PJ_ASSERT_RETURN(session && buf && length, PJ_EINVAL);
Index: /pjproject/trunk/pjmedia/src/pjmedia/sdp.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 4537)
@@ -641,5 +641,5 @@
     /* print connection info, if present. */
     if (m->conn) {
-	printed = print_connection_info(m->conn, p, end-p);
+	printed = print_connection_info(m->conn, p, (int)(end-p));
 	if (printed < 0) {
 	    return -1;
@@ -650,5 +650,5 @@
     /* print optional bandwidth info. */
     for (i=0; i<m->bandw_count; ++i) {
-	printed = print_bandw(m->bandw[i], p, end-p);
+	printed = (int)print_bandw(m->bandw[i], p, end-p);
 	if (printed < 0) {
 	    return -1;
@@ -659,5 +659,5 @@
     /* print attributes. */
     for (i=0; i<m->attr_count; ++i) {
-	printed = print_attr(m->attr[i], p, end-p);
+	printed = (int)print_attr(m->attr[i], p, end-p);
 	if (printed < 0) {
 	    return -1;
@@ -666,5 +666,5 @@
     }
 
-    return p-buf;
+    return (int)(p-buf);
 }
 
@@ -806,5 +806,5 @@
     /* Connection line (c=) if exist. */
     if (ses->conn) {
-	printed = print_connection_info(ses->conn, p, end-p);
+	printed = print_connection_info(ses->conn, p, (int)(end-p));
 	if (printed < 1) {
 	    return -1;
@@ -815,5 +815,5 @@
     /* print optional bandwidth info. */
     for (i=0; i<ses->bandw_count; ++i) {
-	printed = print_bandw(ses->bandw[i], p, end-p);
+	printed = (int)print_bandw(ses->bandw[i], p, end-p);
 	if (printed < 1) {
 	    return -1;
@@ -838,5 +838,5 @@
     /* Print all attribute (a=) lines. */
     for (i=0; i<ses->attr_count; ++i) {
-	printed = print_attr(ses->attr[i], p, end-p);
+	printed = (int)print_attr(ses->attr[i], p, end-p);
 	if (printed < 0) {
 	    return -1;
@@ -847,5 +847,5 @@
     /* Print media (m=) lines. */
     for (i=0; i<ses->media_count; ++i) {
-	printed = print_media_desc(ses->media[i], p, end-p);
+	printed = print_media_desc(ses->media[i], p, (int)(end-p));
 	if (printed < 0) {
 	    return -1;
@@ -854,5 +854,5 @@
     }
 
-    return p-buf;
+    return (int)(p-buf);
 }
 
Index: /pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c	(revision 4536)
+++ /pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c	(revision 4537)
@@ -911,5 +911,5 @@
 			   const pj_str_t *old_pt, const pj_str_t *new_pt)
 {
-    int len_diff = new_pt->slen - old_pt->slen;
+    int len_diff = (int)(new_pt->slen - old_pt->slen);
 
     /* Note that attribute value should be null-terminated. */
